"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class AuditLog(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "code",
        "interpretationRequestId",
        "interpretationRequestVersion",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "addedVariants": reports_5_0_0.ReportedVariant,
            "caseShared": reports_5_0_0.CaseShared,
            "modifiedVariants": reports_5_0_0.ModifiedVariant,
            "removedVariants": reports_5_0_0.ReportedVariant,
            "supportingEvidences": reports_5_0_0.SupportingEvidences,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "code": reports_5_0_0.Code,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "org.gel.models.report.avro.ReportedVariant": reports_5_0_0.ReportedVariant,
            "org.gel.models.report.avro.CaseShared": reports_5_0_0.CaseShared,
            "org.gel.models.report.avro.Code": reports_5_0_0.Code,
            "org.gel.models.report.avro.ModifiedVariant": reports_5_0_0.ModifiedVariant,
            "org.gel.models.report.avro.ReportedVariant": reports_5_0_0.ReportedVariant,
            "org.gel.models.report.avro.SupportingEvidences": reports_5_0_0.SupportingEvidences,
            "org.gel.models.report.avro.AuditLog": reports_5_0_0.AuditLog,
        }

    __slots__ = [
        "code",
        "interpretationRequestId",
        "interpretationRequestVersion",
        "addedVariants",
        "caseShared",
        "modifiedVariants",
        "removedVariants",
        "supportingEvidences",
    ]

    def __init__(
        self,
        code,
        interpretationRequestId,
        interpretationRequestVersion,
        addedVariants=None,
        caseShared=None,
        modifiedVariants=None,
        removedVariants=None,
        supportingEvidences=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_5_0_0.AuditLog model.

        :param code:
        :type code: Code
        :param interpretationRequestId:
            This is the interpretation Request Id, first number in XXX-123-1
        :type interpretationRequestId: str
        :param interpretationRequestVersion:
            This is the version of the interpretation Request Id, second number in
            XXX-123-2
        :type interpretationRequestVersion: str
        :param addedVariants:
        :type addedVariants: None | list[ReportedVariant]
        :param caseShared:
        :type caseShared: None | CaseShared
        :param modifiedVariants:
        :type modifiedVariants: None | list[ModifiedVariant]
        :param removedVariants:
        :type removedVariants: None | list[ReportedVariant]
        :param supportingEvidences:
        :type supportingEvidences: None | SupportingEvidences
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "5.0.0"
